package to.newfs.webauth.colorselector;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.colorchooser.*;
import java.awt.*;
import java.awt.event.*;


class KeywordColorChooserPanel extends AbstractColorChooserPanel
  implements ActionListener {
  JButton[] buttons;
  static final String displayName = "Keyword";
  private final int[] defcolors = {
    0x00, 0x00, 0x00, // Black
    0xc0, 0xc0, 0xc0, // Silver
    0x80, 0x80, 0x80, // Gray
    0xff, 0xff, 0xff, // White
    0x80, 0x00, 0x00, // Maroon
    0xff, 0x00, 0x00, // Red
    0x80, 0x00, 0x80, // Purple
    0xff, 0x00, 0xff, // Fuchsia
    0x00, 0x80, 0x00, // Green
    0x00, 0xff, 0x00, // Lime
    0x80, 0x80, 0x00, // Olive
    0xff, 0xff, 0x00, // Yellow
    0x00, 0x00, 0x80, // Navy
    0x00, 0x00, 0xff, // Blue
    0x00, 0x80, 0x80, // Teal
    0x00, 0xff, 0xff, // Aqua
  };
  private final String[] cnames = {
    "Black", "Silver", "Gray", "White", "Maroon", "Red", "Purple", "Fuchsia",
    "Green", "Lime", "Olive", "Yellow", "Navy", "Blue", "Teal", "Aqua",
  };

  public KeywordColorChooserPanel() {
    super();
  }
  public void setColor(Color newColor) {
  }
  public String getDisplayName() {
    return displayName;
  }
  public Icon getSmallDisplayIcon() {
    return null;
  }
  public Icon getLargeDisplayIcon() {
    return null;
  }
  public void installChooserPanel(JColorChooser enclosingChooser) {
    super.installChooserPanel(enclosingChooser);
  }
  private void initButtons() {
    buttons = new JButton[16];
    for (int i = 0; i < cnames.length; i++) {
      buttons[i] = new JButton(cnames[i]);
      int r = defcolors[i * 3];
      int g = defcolors[i * 3 + 1];
      int b = defcolors[i * 3 + 2];
      Color c = new Color(r, g, b);
      buttons[i].setBackground(c);
      if (r + g + b < 128 * 3) {
	buttons[i].setForeground(new Color(255, 255, 255));
      }
      buttons[i].setToolTipText(r + "," + g + "," + b);
      buttons[i].setActionCommand(cnames[i]);
      buttons[i].addActionListener(this);
    }
  }

  protected void buildChooser() {
    initButtons();
    setLayout(new BorderLayout());
    Color color = getColorFromModel();
    JPanel grid = new JPanel();
    grid.setLayout(new GridLayout(4, 4));
    add(grid, BorderLayout.CENTER);
    for (int i = 0; i < buttons.length; i++) {
      grid.add(buttons[i]);
    }
  }
  public void uninstallChooserPanel(JColorChooser enclosingChooser) {
    super.uninstallChooserPanel(enclosingChooser);
  }
  public void actionPerformed(ActionEvent ev) {
    String cmd = ev.getActionCommand();
    int i;
    for (i = 0; i < cnames.length; i++) {
      if (cnames[i] == cmd)
	break;
    }
    Color c = new Color(defcolors[i * 3], defcolors[i * 3 + 1], defcolors[i * 3 + 2]);
    getColorSelectionModel().setSelectedColor(c);
  }
  public void updateChooser() {
    /*
    if (isAdjusting) {
      return;
    }
    //	System.out.println("Adjusting");
    isAdjusting = true;

    Color color = getColorFromModel();
    int red = color.getRed();
    int blue = color.getBlue();
    int green = color.getGreen();


    redSlider.setValue(red);
    blueSlider.setValue(blue);
    greenSlider.setValue(green);

    if ( redField.getIntegerValue() != red )
      redField.setText(String.valueOf(color.getRed()));
    if ( greenField.getIntegerValue() != green )
      greenField.setText(String.valueOf(color.getGreen()));
    if ( blueField.getIntegerValue() != blue )
      blueField.setText(String.valueOf(color.getBlue()));


    isAdjusting = false;
    //	System.out.println("Calling update");
    */
  }
}


